#!/usr/bin/python3
import pathlib
import getpass

# LightBoxRebuildRecent
# v.1.02a
# by Thinkit


username=getpass.getuser()


# CONFIG 
# define paths to scan
# QuickSave, projects, assets, and ZBrush installation
pathsToScanExtDict = {
0:['/home/'+username+'/.wine/drive_c/users/Public/Documents/ZBrushData2021/QuickSave/','zpr'],
1:['/home/'+username+'/.wine/drive_c/users/Public/Documents/ZBrushData2021/QuickSave/','ZPR'],
2:['/home/'+username+'/.wine/drive_c/Program Files/Pixologic/ZBrush 2021/','zpr'],
3:['/home/'+username+'/.wine/drive_c/Program Files/Pixologic/ZBrush 2021/','ZPR'],
4:['/home/'+username+'/.wine/drive_c/Program Files/Pixologic/ZBrush 2021/','ztl'],
5:['/home/'+username+'/.wine/drive_c/Program Files/Pixologic/ZBrush 2021/','ZTL'],
}

# define path to LightboxRecentFiles.cfg
pathToLightboxRecentFiles_cfg = '/home/'+username+'/.wine/drive_c/users/Public/Documents/ZBrushData2021/ZStartup/ConfigFiles/LightboxRecentFiles.cfg'






LightboxRecentPartialSequence = ''
LightboxRecentFinalSequence = ''
counter = 0


def makeLightBoxRecentPartialSequence(partialSequencePath='',ext='zpr',is_reverse=True):
    LightBoxRecentPartialSequence = ''
    files_list = []

    global counter
    for path in pathlib.Path(partialSequencePath).rglob('*.'+ext):
        files_list.append(path.resolve())
        counter += 1

    files_list.sort(reverse=is_reverse) 
    delimiter=bytes.fromhex('00').decode('utf-8')
    for i in files_list:
        LightBoxRecentPartialSequence += str(i)+delimiter

    LightBoxRecentPartialSequence = LightBoxRecentPartialSequence.replace('/home/'+username+'/.wine/drive_c', 'C:\\')
    LightBoxRecentPartialSequence = LightBoxRecentPartialSequence.replace('/', '\\')

    return LightBoxRecentPartialSequence


def write_to_file(data="test",file="/tmp/tmp.txt",append=False):
    if append:
        """append data to specified file"""
        with open(file, 'a') as the_file:
        	the_file.write(data)
    else:
        """write or overwrite data in specified file"""
        with open(file, 'w') as the_file:
        	the_file.write(data)


for key, values in pathsToScanExtDict.items():
    path=values[0]
    ext=values[1]

    LightBoxRecentPartialSequence = makeLightBoxRecentPartialSequence(partialSequencePath=path,ext=ext,is_reverse=True)
    LightboxRecentFinalSequence += LightBoxRecentPartialSequence


print(LightboxRecentFinalSequence)
print('')
print('Found items:',counter)
print('Press LightBox and then Recent in ZBrush to see the update')
print('')


write_to_file(data=LightboxRecentFinalSequence, file=pathToLightboxRecentFiles_cfg)